USE [COWS_Reporting]
GO
--==================================================================================

-- Date:			08/05/2014
-- Description:		
--					GOM CCD and RTS Report.
--					Group Type:  GOM
--
-- TEST: EXEC COWS_Reporting.dbo.sp_GOMRptCcdRts 
--
--==================================================================================
ALTER PROCEDURE [dbo].[sp_GOMRptCcdRts] 
	@secured			BIT=1


AS
BEGIN TRY

	SET NOCOUNT ON;
	
	DECLARE @startDate		Datetime = GETDATE()
	DECLARE @endDate		Datetime = GETDATE()
	

	SET @endDate=DATEADD(day, 1, @endDate)
	set @startDate = DATEADD(day, -365,@startDate) 

    

	OPEN SYMMETRIC KEY FS@K3y 
	DECRYPTION BY CERTIFICATE S3cFS@CustInf0; 

	SELECT DISTINCT 
		ISNULL(fo.PRNT_FTN, '')[Parent FTN]
		,CASE 
			WHEN o.ORDR_CAT_ID=1 THEN Convert(varchar(50), ipo.ORDR_ID) 
			WHEN o.ORDR_CAT_ID=6 THEN fo.FTN
			WHEN o.ORDR_CAT_ID=2 THEN fo.FTN END [Order Tracking FTN]
		--,CASE
		--	WHEN o.ORDR_CAT_ID=6 AND @secured = 1 AND o.SCURD_CD = 1 THEN CONVERT(VARCHAR, DecryptByKey(si.CUST_NME))
		--	WHEN o.ORDR_CAT_ID=6 AND @secured = 1 AND o.SCURD_CD = 0 THEN CONVERT(VARCHAR, DecryptByKey(si.CUST_NME))	
		--	WHEN o.ORDR_CAT_ID=6 AND @secured = 0 AND o.SCURD_CD = 1 AND CONVERT(VARCHAR, DecryptByKey(si.CUST_NME)) IS NOT NULL THEN 'PRIVATE CUSTOMER' 
		--	WHEN o.ORDR_CAT_ID=6 AND @secured = 0 AND o.SCURD_CD = 1 AND CONVERT(VARCHAR, DecryptByKey(si.CUST_NME)) IS NULL THEN ''
		--	WHEN o.ORDR_CAT_ID=2 AND @secured = 1 AND o.SCURD_CD = 1 THEN CONVERT(VARCHAR, DecryptByKey(si.CUST_NME))
		--	WHEN o.ORDR_CAT_ID=2 AND @secured = 1 AND o.SCURD_CD = 0 THEN CONVERT(VARCHAR, DecryptByKey(si.CUST_NME))	
		--	WHEN o.ORDR_CAT_ID=2 AND @secured = 0 AND o.SCURD_CD = 1 AND CONVERT(VARCHAR, DecryptByKey(si.CUST_NME)) IS NOT NULL THEN 'PRIVATE CUSTOMER' 
		--	WHEN o.ORDR_CAT_ID=2 AND @secured = 0 AND o.SCURD_CD = 1 AND CONVERT(VARCHAR, DecryptByKey(si.CUST_NME)) IS NULL THEN '' 
		--	WHEN o.ORDR_CAT_ID=1 AND @secured = 1 AND o.SCURD_CD = 1 THEN CONVERT(VARCHAR, DecryptByKey(h5f2.CUST_NME))
		--	WHEN o.ORDR_CAT_ID=1 AND @secured = 1 AND o.SCURD_CD = 0 THEN CONVERT(VARCHAR, DecryptByKey(h5f2.CUST_NME))	
		--	WHEN o.ORDR_CAT_ID=1 AND @secured = 0 AND o.SCURD_CD = 1 AND CONVERT(VARCHAR, DecryptByKey(h5f2.CUST_NME)) IS NOT NULL THEN 'PRIVATE CUSTOMER' 
		--	WHEN o.ORDR_CAT_ID=1 AND @secured = 0 AND o.SCURD_CD = 1 AND CONVERT(VARCHAR, DecryptByKey(h5f2.CUST_NME)) IS NULL THEN '' 
		--	ELSE ISNULL(CONVERT(VARCHAR, DecryptByKey(h5f2.CUST_NME)),CONVERT(VARCHAR, DecryptByKey(si.CUST_NME))) END [Sprint Customer Name]
			
		,CASE o.ORDR_CAT_ID
			      WHEN 6 THEN
						 CASE  
							WHEN @secured = 0 AND o.CSG_LVL_ID =0 THEN  si.CUST_NME
							WHEN @secured = 0 AND o.CSG_LVL_ID >0 AND si.CUST_NME2 IS NOT NULL THEN  'PRIVATE CUSTOMER'
							WHEN @secured = 0 AND o.CSG_LVL_ID >0 AND si.CUST_NME2 IS NULL THEN  ''
							ELSE  COALESCE(si.CUST_NME2,si.CUST_NME,'') END
				  WHEN 2 THEN
						 CASE  
							WHEN @secured = 0 AND o.CSG_LVL_ID =0 THEN  si.CUST_NME
							WHEN @secured = 0 AND o.CSG_LVL_ID >0 AND si.CUST_NME2 IS NOT NULL THEN  'PRIVATE CUSTOMER'
							WHEN @secured = 0 AND o.CSG_LVL_ID >0 AND si.CUST_NME2 IS NULL THEN  ''
							ELSE  COALESCE(si.CUST_NME2,si.CUST_NME,'') END
				  WHEN 1 THEN
						 CASE  
							WHEN @secured = 0 AND o.CSG_LVL_ID =0 THEN  h5f2.CUST_NME
							WHEN @secured = 0 AND o.CSG_LVL_ID >0 AND CONVERT(VARCHAR, DecryptByKey(csd.CUST_NME)) IS NOT NULL THEN  'PRIVATE CUSTOMER'
							WHEN @secured = 0 AND o.CSG_LVL_ID >0 AND CONVERT(VARCHAR, DecryptByKey(csd.CUST_NME)) IS NULL THEN  ''
							ELSE  COALESCE(csd.CUST_NME,h5f2.CUST_NME,'') END			
			 ELSE COALESCE(CONVERT(VARCHAR, DecryptByKey(csd.CUST_NME)),si.CUST_NME,si.CUST_NME2,'' ) 			
			 
			 END [Sprint Customer Name] 	
		,ISNULL(o.H5_H6_CUST_ID,ipo.H5_CUST_ACCT_NBR) [H5 ID]
		,CASE 
			WHEN o.ORDR_CAT_ID=1 THEN ISNULL(lpt.PROD_TYPE_DES,'')
			WHEN o.ORDR_CAT_ID=6 THEN ISNULL(lfpt.FSA_PROD_TYPE_DES,'')
			WHEN o.ORDR_CAT_ID=2 THEN ISNULL(lfpt.FSA_PROD_TYPE_DES,'') END [Product]
		,ISNULL(ost.ORDR_SUB_TYPE_DES,'') [Order Sub-type]
		,CASE 
			WHEN o.ORDR_CAT_ID=1 THEN ISNULL(lot.ORDR_TYPE_DES,'')
			WHEN o.ORDR_CAT_ID=6 THEN ISNULL(lfot.FSA_ORDR_TYPE_DES,'')
			WHEN o.ORDR_CAT_ID=2 THEN ISNULL(lfot.FSA_ORDR_TYPE_DES,'') END [Service Request Type]

		,CASE 
			WHEN o.ORDR_CAT_ID=1 THEN ISNULL(CONVERT(VARCHAR(10),ipo.CUST_WANT_DT,101),'')
			WHEN o.ORDR_CAT_ID=6 THEN ISNULL(CONVERT(VARCHAR(10),fo.CUST_WANT_DT,101),'')
			WHEN o.ORDR_CAT_ID=2 THEN ISNULL(CONVERT(VARCHAR(10),fo.CUST_WANT_DT,101),'') END [Customer Want Date]
		,CASE 
			WHEN o.ORDR_CAT_ID=1 THEN ISNULL(CONVERT(VARCHAR(10),ipo.CUST_CMMT_DT,101),'')
			WHEN o.ORDR_CAT_ID=6 THEN ISNULL(CONVERT(VARCHAR(10),fo.CUST_CMMT_DT,101),'')
			WHEN o.ORDR_CAT_ID=2 THEN ISNULL(CONVERT(VARCHAR(10),fo.CUST_CMMT_DT,101),'') END [Customer Commit Date]
		,ISNULL(ccd.DSPL_NME,'') [CCD Change Requestor]
		,ISNULL(CONVERT(VARCHAR (10),ccd.NEW_CCD_DT, 101),'') [New CCD]
		,ISNULL(cnt.CNT,0) [CCD Request Count]
		,ISNULL(cmr.CCD_MISSD_REAS_DES, '') [CCD Reason]
		,ISNULL(ccd.NTE_TXT,'') [CCD Change Comments]

		,CASE
			WHEN fo.ORDR_TYPE_CD='CN' AND fo.PRNT_FTN IS NOT NULL THEN ISNULL(cn.[Name],'')
			ELSE ISNULL(lu.[DSPL_NME],'') END [Assigned]
		,CASE
			WHEN fo.PRE_SBMT_CREAT_DT IS NOT NULL THEN CONVERT(VARCHAR(16),fo.PRE_SBMT_CREAT_DT,121) 
			WHEN ms.PRE_SBMT_DT IS NOT NULL THEN CONVERT(VARCHAR(16),ms.PRE_SBMT_DT,121)
			WHEN fo.ORDR_TYPE_CD='CN' AND fo.PRNT_FTN IS NOT NULL THEN CONVERT(VARCHAR(16),cn.ASMT_DT,121)
			ELSE ISNULL(CONVERT(VARCHAR(16),uwa.ASMT_DT,121),'') END [Assigned Date]
		,CASE 
			WHEN ont2.NOTE_DT IS NOT NULL THEN CONVERT(VARCHAR(16),ont2.NOTE_DT,121)
			WHEN fo.PROD_TYPE_CD IN ('DN','DO','MP','MO','SN','SO') AND ms.SBMT_DT IS NOT NULL THEN CONVERT(VARCHAR(16),ms.SBMT_DT,121)
			ELSE ISNULL(CONVERT(VARCHAR(16),fo.ORDR_SBMT_DT,121),'') END  [Order Submit Date]
		
		,ISNULL(lks.ORDR_STUS_DES,'') [Order Status]
		,ISNULL([Task Status],'') [Task Status]
		,ISNULL([Work Group],'') [Work Group]
		,CASE 
			WHEN o.ORDR_CAT_ID=1 THEN ISNULL(ipo.SALS_BR_NME,'')
			WHEN o.ORDR_CAT_ID=6 THEN ISNULL(si.BR_CD,'')
			WHEN o.ORDR_CAT_ID=2 THEN ISNULL(si.BR_CD,'') END [Sales Branch]
		,CASE 
			WHEN o.ORDR_CAT_ID=1 THEN ISNULL(ipo.SOI,'')
			WHEN o.ORDR_CAT_ID=6 THEN ISNULL(si.SOI_CD,'')
			WHEN o.ORDR_CAT_ID=2 THEN ISNULL(si.SOI_CD,'') END [Sales Office]

		--,CASE 
		--	WHEN fo.ORDR_ACTN_ID = 1 THEN ISNULL(CONVERT(VARCHAR(10),psrts.[PS RTS Date],121),'')
		--	WHEN fo.ORDR_ACTN_ID = 2 THEN ISNULL(CONVERT(VARCHAR(10),srts.[S RTS Date],121),'') 
		--	ELSE ISNULL(CONVERT(VARCHAR(10),note.CREAT_DT,121),'') END [RTS Date]
		,ISNULL(CONVERT(VARCHAR(10),note.CREAT_DT,121),'')  [RTS Date]
		,ISNULL(note.NTE_TXT,'') [RTS Comments]
	
	
	FROM COWS.dbo.ORDR o with (nolock) 
		LEFT OUTER JOIN COWS.dbo.FSA_ORDR fo WITH (NOLOCK) ON o.ORDR_ID = fo.ORDR_ID
		LEFT OUTER JOIN COWS.dbo.ORDR_MS ms WITH (NOLOCK) ON o.ORDR_ID = ms.ORDR_ID
		LEFT OUTER JOIN (SELECT ORDR_ID,ORDR_TYPE_ID,PROD_TYPE_ID,CREAT_DT,CUST_CNTRC_SIGN_DT,CUST_ORDR_SBMT_DT,CUST_WANT_DT,CUST_CMMT_DT,SALS_BR_NME,SOI
				,H5_CUST_ACCT_NBR 
			FROM COWS.dbo.IPL_ORDR WITH (NOLOCK) WHERE ORDR_STUS_ID <> 20
			) ipo ON o.ORDR_ID = ipo.ORDR_ID
		LEFT OUTER JOIN ( SELECT ORDR_ID, MIN(CREAT_DT) [NOTE_DT] FROM COWS.dbo.ORDR_NTE WITH (NOLOCK) GROUP BY ORDR_ID)ont ON o.ORDR_ID = ont.ORDR_ID
		LEFT OUTER JOIN ( SELECT ORDR_ID, MIN(CREAT_DT) [NOTE_DT] FROM COWS.dbo.ORDR_NTE WITH (NOLOCK) WHERE NTE_TXT = 'Completing GOM Submit Task.' GROUP BY ORDR_ID)ont2 ON o.ORDR_ID = ont2.ORDR_ID
		--LEFT OUTER JOIN COWS.dbo.NRM_CKT nc WITH (NOLOCK) ON nc.FTN = fo.FTN
		--LEFT OUTER JOIN (SELECT DISTINCT ORDR_ID,LOCAL_ACCS_TYPE_ID 
		--	FROM COWS.dbo.IPL_ORDR_ACCS_INFO WITH (NOLOCK) WHERE LOCAL_ACCS_TYPE_ID IS NOT NULL
		--	) llat ON llat.ORDR_ID = o.ORDR_ID
		LEFT OUTER JOIN COWS.dbo.H5_FOLDR h5f2 WITH (NOLOCK) ON h5f2.CUST_ID = ipo.H5_CUST_ACCT_NBR
		LEFT OUTER JOIN [COWS].dbo.CUST_SCRD_DATA csd WITH (NOLOCK) ON csd.SCRD_OBJ_ID=h5f2.H5_FOLDR_ID  AND csd.SCRD_OBJ_TYPE_ID=6
		LEFT OUTER JOIN (SELECT ORDR_ID, CTRY_CD, CTY_NME FROM COWS.dbo.ORDR_ADR WITH (NOLOCK) WHERE CIS_LVL_TYPE in ('H5','H6','ES'))oa ON oa.ORDR_ID = o.ORDR_ID						
		LEFT OUTER JOIN (SELECT ORDR_ID,ASN_USER_ID [USER_ID],ASMT_DT FROM COWS.dbo.USER_WFM_ASMT WITH (NOLOCK) WHERE GRP_ID = 1) uwa ON uwa.ORDR_ID=o.ORDR_ID
		LEFT OUTER JOIN COWS.dbo.LK_USER lu WITH (NOLOCK) ON uwa.USER_ID = lu.[USER_ID]
		LEFT OUTER JOIN COWS.dbo.LK_FSA_ORDR_TYPE lfot WITH (NOLOCK) ON lfot.FSA_ORDR_TYPE_CD = fo.ORDR_TYPE_CD
		LEFT OUTER JOIN COWS.dbo.LK_ORDR_STUS lks WITH (NOLOCK) ON lks.ORDR_STUS_ID=o.ORDR_STUS_ID
		LEFT OUTER JOIN COWS.dbo.LK_ORDR_TYPE lot WITH (NOLOCK) ON lot.ORDR_TYPE_ID = ipo.ORDR_TYPE_ID
		LEFT OUTER JOIN COWS.dbo.LK_FSA_PROD_TYPE lfpt WITH (NOLOCK) ON lfpt.FSA_PROD_TYPE_CD = fo.PROD_TYPE_CD
		LEFT OUTER JOIN COWS.dbo.LK_PROD_TYPE lpt WITH (NOLOCK) ON lpt.PROD_TYPE_ID = ipo.PROD_TYPE_ID
		LEFT OUTER JOIN (SELECT DISTINCT o.ORDR_ID,lg.GRP_NME [Work Group]
				,CASE 
					WHEN TASK_NME = 'Bill Activated' THEN ''
					ELSE TASK_NME + '-' + lsa.STUS_DES 
				END [Task Status]
			FROM (SELECT ORDR_ID,WG_PTRN_ID,STUS_ID,CREAT_DT
				FROM COWS.dbo.WG_PTRN_STUS WITH (NOLOCK) 
				WHERE STUS_ID=0 
			) w
			JOIN COWS.dbo.ORDR o WITH (NOLOCK) ON o.ORDR_ID=w.ORDR_ID
			JOIN (
				SELECT wpfs.ORDR_ID,WG_PTRN_ID,pfs.WG_PROF_ID,STUS_ID,wpfs.CREAT_DT FROM COWS.dbo.WG_PROF_STUS wpfs WITH (NOLOCK) 
				JOIN (SELECT ORDR_ID,MIN(WG_PROF_ID)[WG_PROF_ID],MIN(CONVERT(VARCHAR(16),CREAT_DT,121))[CREAT_DT] FROM COWS.dbo.WG_PROF_STUS  WITH (NOLOCK)
				WHERE STUS_ID=0 GROUP BY ORDR_ID) pfs ON pfs.ORDR_ID=wpfs.ORDR_ID AND pfs.CREAT_DT=wpfs.CREAT_DT AND pfs.WG_PROF_ID=wpfs.WG_PROF_ID
				WHERE wpfs.STUS_ID=0
			) wps ON wps.WG_PTRN_ID=w.WG_PTRN_ID AND wps.ORDR_ID=w.ORDR_ID --AND wps.CREAT_DT=w.CREAT_DT 
						AND wps.STUS_ID=w.STUS_ID
			LEFT OUTER JOIN (	
				SELECT DISTINCT at.ORDR_ID,mgt.GRP_ID,at.TASK_ID,at.WG_PROF_ID,STUS_ID [atSTUSID]
				FROM COWS.dbo.ACT_TASK at WITH (NOLOCK) 
				LEFT OUTER JOIN (SELECT ORDR_ID,MIN(WG_PROF_ID)[WG_PROF_ID],MIN(CONVERT(VARCHAR(16),CREAT_DT,121))[CREAT_DT] FROM COWS.dbo.WG_PROF_STUS  WITH (NOLOCK)
					GROUP BY ORDR_ID) pfs ON pfs.ORDR_ID=at.ORDR_ID 
						--AND pfs.CREAT_DT=at.CREAT_DT 
						AND pfs.WG_PROF_ID=at.WG_PROF_ID
				LEFT OUTER JOIN (SELECT TASK_ID, MIN(GRP_ID)[GRP_ID] FROM COWS.dbo.MAP_GRP_TASK WITH (NOLOCK) GROUP BY TASK_ID) mgt ON mgt.TASK_ID=at.TASK_ID
				WHERE at.STUS_ID NOT IN (1, 2)
				) mat ON mat.ORDR_ID=wps.ORDR_ID AND mat.WG_PROF_ID=wps.WG_PROF_ID
			LEFT OUTER JOIN COWS.dbo.LK_ORDR_STUS lks WITH (NOLOCK) ON lks.ORDR_STUS_ID=o.ORDR_STUS_ID
			LEFT OUTER JOIN COWS.dbo.LK_GRP lg WITH (NOLOCK) ON lg.GRP_ID=mat.GRP_ID
			LEFT OUTER JOIN COWS.dbo.LK_STUS lsw WITH (NOLOCK) ON lsw.STUS_ID=w.STUS_ID
			LEFT OUTER JOIN COWS.dbo.LK_STUS lsa WITH (NOLOCK) ON lsa.STUS_ID=mat.[atSTUSID]
			LEFT OUTER JOIN COWS.dbo.LK_STUS lsp WITH (NOLOCK) ON lsp.STUS_ID=wps.STUS_ID
			LEFT OUTER JOIN COWS.dbo.LK_TASK lt WITH (NOLOCK) ON lt.TASK_ID=mat.TASK_ID
		) x ON x.ORDR_ID = o.ORDR_ID
		LEFT OUTER JOIN (SELECT ORDR_ID,MAX(CREAT_DT)[PS RTS Date]
			 FROM COWS.dbo.ORDR_NTE
			 WHERE NTE_TYPE_ID in (14,21) 
			 GROUP BY ORDR_ID		
		) psrts ON psrts.ORDR_ID = o.ORDR_ID 
		LEFT OUTER JOIN (SELECT act.ORDR_ID,act.CREAT_DT [S RTS Date] 
			FROM [COWS].[dbo].[ACT_TASK] act WITH (NOLOCK) 
			WHERE act.ACT_TASK_ID = (SELECT MAX(ACT_TASK_ID)
				FROM (SELECT ACT_TASK_ID,ORDR_ID FROM [COWS].[dbo].[ACT_TASK] WITH (NOLOCK) WHERE TASK_ID=500 AND STUS_ID=0) act1 
			WHERE act1.ORDR_ID = act.ORDR_ID)
		)srts ON srts.ORDR_ID = o.ORDR_ID		
		LEFT OUTER JOIN (SELECT ORDR_ID2,Name,ASMT_DT FROM (
			SELECT [ORDR_ID2]
				,CASE 
					WHEN uwa.[ASN_USER_ID] IS NOT NULL THEN lku.DSPL_NME
					ELSE c.[Name] END [Name]
				,CASE 
					WHEN uwa.[ASMT_DT] IS NOT NULL THEN uwa.[ASMT_DT]
					ELSE c.[ASMT_DT] END [ASMT_DT]
			FROM (SELECT ont.ORDR_ID, MAX(NTE_ID) [NTE_ID], MAX(ont.CREAT_DT) [ASMT_DT],ont.CREAT_BY_USER_ID [USER_ID],DSPL_NME [Name]
					,[ORDR_ID1],[ORDR_ID2] 
				FROM COWS.dbo.ORDR_NTE ont WITH (NOLOCK)
				JOIN (SELECT fo1.ORDR_ID [ORDR_ID1],fo2.ORDR_ID [ORDR_ID2]
					FROM COWS.dbo.FSA_ORDR fo1 WITH (NOLOCK) 
					JOIN (SELECT ORDR_ID,FTN,PRNT_FTN,ORDR_TYPE_CD,RELTD_FTN FROM COWS.dbo.FSA_ORDR WITH (NOLOCK) 
						WHERE ORDR_ACTN_ID <> 3 AND PRNT_FTN IS NOT NULL
					) fo2 ON fo2.PRNT_FTN = fo1.FTN
				) fo ON fo.ORDR_ID1=ont.ORDR_ID
				LEFT OUTER JOIN COWS.dbo.LK_USER lu WITH (NOLOCK) ON lu.[USER_ID]=ont.CREAT_BY_USER_ID
				WHERE ont.NTE_TYPE_ID IN (9,10) AND ont.CREAT_BY_USER_ID <> 1 
				GROUP BY ont.ORDR_ID, ont.CREAT_BY_USER_ID, DSPL_NME,[ORDR_ID1],[ORDR_ID2]  
			)c
			LEFT OUTER JOIN (SELECT * FROM COWS.dbo.USER_WFM_ASMT WITH (NOLOCK) WHERE GRP_ID = 1) uwa ON uwa.ORDR_ID=c.ORDR_ID2
			LEFT OUTER JOIN COWS.dbo.LK_USER lku WITH (NOLOCK) ON lku.[USER_ID]=uwa.ASN_USER_ID
		)cc ) cn ON cn.ORDR_ID2=o.ORDR_ID
		LEFT OUTER JOIN (SELECT bb.ORDR_ID, bb.SOI_CD, bb.CUST_NME, bb.BR_CD, bb.CIS_LVL_TYPE,CONVERT(varchar, DecryptByKey(csd.CUST_NME)) AS CUST_NME2
 			FROM COWS.dbo.FSA_ORDR_CUST bb WITH (NOLOCK)
 			LEFT OUTER JOIN COWS.dbo.FSA_ORDR cc WITH (NOLOCK) ON  bb.ORDR_ID = cc.ORDR_ID 
 			LEFT OUTER JOIN [COWS].dbo.CUST_SCRD_DATA csd WITH (NOLOCK) ON csd.SCRD_OBJ_ID=bb.FSA_ORDR_CUST_ID  AND csd.SCRD_OBJ_TYPE_ID=5
			WHERE (CIS_LVL_TYPE in ('H5', 'H6', 'ES'))) si ON si.ORDR_ID = fo.ORDR_ID 
		LEFT OUTER JOIN COWS.dbo.LK_ORDR_SUB_TYPE ost WITH (NOLOCK) on ost.ORDR_SUB_TYPE_CD = fo.ORDR_SUB_TYPE_CD 
	    LEFT OUTER JOIN (SELECT CCD_HIST_ID, c.ORDR_ID, NEW_CCD_DT,n.NTE_TXT, cu.DSPL_NME 
				FROM COWS.dbo.CCD_HIST c 
			LEFT OUTER JOIN COWS.dbo.LK_USER cu on cu.USER_ID = c.CREAT_BY_USER_ID
			LEFT OUTER JOIN COWS.dbo.ORDR_NTE n on c.NTE_ID = n.NTE_ID
				WHERE CCD_HIST_ID = (SELECT MAX(CCD_HIST_ID)
			FROM (SELECT CCD_HIST_ID, ORDR_ID FROM [COWS].[dbo].[CCD_HIST] ) cd
			WHERE cd.ORDR_ID = c.ORDR_ID))ccd on ccd.ORDR_ID = o.ORDR_ID
		
		LEFT OUTER JOIN COWS.dbo.CCD_HIST_REAS cch on ccd.CCD_HIST_ID = cch.CCD_HIST_ID
		LEFT OUTER JOIN COWS.dbo.LK_CCD_MISSD_REAS cmr WITH (NOLOCK) ON cch.CCD_MISSD_REAS_ID = cmr.CCD_MISSD_REAS_ID 	
		LEFT OUTER JOIN (SELECT NTE_ID, NTE_TYPE_ID,ORDR_ID,NTE_TXT, CREAT_DT FROM COWS.dbo.ORDR_NTE  nte
							WHERE NTE_ID = (SELECT MAX(NTE_ID) FROM 
							(SELECT NTE_ID, ORDR_ID, NTE_TYPE_ID FROM COWS.dbo.ORDR_NTE)nt WHERE nt.ORDR_ID = nte.ORDR_ID
										AND NTE_TYPE_ID in (14,21))) note 
							ON note.ORDR_ID = o.ORDR_ID
		LEFT OUTER JOIN (SELECT COUNT(CCD_HIST_ID) [CNT], ORDR_ID FROM COWS.dbo.CCD_HIST
							GROUP BY ORDR_ID)cnt on cnt.ORDR_ID = o.ORDR_ID
	
	
	WHERE (ipo.ORDR_ID IS NOT NULL OR fo.FTN IS NOT NULL)
		AND o.ORDR_CAT_ID in (1,2,6)
		AND ((fo.CREAT_DT >= @startDate AND fo.CREAT_DT < @endDate) 
				OR (ipo.CREAT_DT >= @startDate AND ipo.CREAT_DT < @endDate)) 
		AND (ISNULL(note.ORDR_ID,'') <> '' OR ISNULL(ccd.ORDR_ID,'') <> '')

		
	CLOSE SYMMETRIC KEY FS@K3y 

	RETURN 0;
	
END TRY

BEGIN CATCH
	DECLARE @Desc VARCHAR(200)
	SET @Desc='EXEC COWS_Reporting.dbo.sp_GOMRptCcdRts '  
	SET @Desc=@Desc + CONVERT(VARCHAR(10), @startDate, 101) + ', ' + CONVERT(VARCHAR(10), @endDate, 101)
	EXEC RAD_Reporting.rad.sp_ReportProcessLog null, @Desc, null, null, null;
	RETURN 1;
END CATCH



